<template>
  <div v-if="this.card">
    <v-card
      class="py-5 pl-5 text-left d-flex align-center justify-space-between mt-3"
      v-for="(step, index) in steps"
      :key="index"
      style="cursor: pointer"
      @click="goTo(step.redirectTo.name)"
    >
      <div class="d-flex align-center" style="min-height: 3em">
        <v-icon v-if="step.active" color="#16C62E" size="28">
          mdi-checkbox-marked-circle
        </v-icon>
        <v-img
          v-else
          :src="
            require('@/assets/img/icons/carbon_checkmark-outline_sin-margen.svg')
          "
        />
        <div
          class="roboto body-idx-text step-text ml-4"
          :style="{ color: step.active ? '#999999' : '#333333' }"
        >
          {{ step.title }}
        </div>
      </div>
    </v-card>
  </div>
  <div v-else>
    <div
      class="py-1 pl-5 text-left d-flex align-center justify-space-between mt-3"
      v-for="(step, index) in steps"
      :key="index"
      style="cursor: pointer"
      @click="goTo(step.redirectTo.name)"
    >
      <div class="d-flex align-center" style="min-height: 3em">
        <v-icon v-if="step.active" color="#16C62E" size="28">
          mdi-checkbox-marked-circle
        </v-icon>
        <v-img
          v-else
          :src="
            require('@/assets/img/icons/carbon_checkmark-outline_sin-margen.svg')
          "
        />
        <div
          class="roboto body-idx-text step-text ml-4"
          :style="{ color: step.active ? '#999999' : '#333333' }"
        >
          {{ step.title }}
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import router from "@/router";

import currentUserService from "@/services/currentUserService";
import dtService from "@/services/dtService";
import CompanyService from "@/services/companyService";
import subscriptionService from "@/services/subscriptionService";
import { mapActions, mapGetters } from "vuex";

export default {
  props: {
    card: { type: Boolean, default: true },
  },
  data() {
    return {
      imtd: 0,
      steps: [],
      company: {},
      percentage: 0,
    };
  },
  created() {
    this.loadSteps();
    this.steps = this.getSteps;
    this.percentage = localStorage.getItem("percentage");
  },
  mounted() {
    this.loadSteps();
  },
  computed: {
    ...mapGetters("UserStore", ["getSteps"]),
  },
  methods: {
    ...mapActions("UserStore", [
      "SET_STEP_INACTIVE",
      "SET_STEP_ACTIVE",
      "SET_IMTD",
    ]),
    goTo(url) {
      if (url) {
        router.push(url);
      }
    },
    loadSteps() {
      this.getImtd();
      this.getCompany();
      this.getSubscription();
    },

    getImtd() {
      currentUserService
        .currentUserData()
        .then((userData) => {
          this.user = userData;
          dtService
            .getSurveyComplete("a123", this.user.id)
            .then((questions) => {
              this.getDti(this.user.id, questions.surveyId);
            })
            .catch((err) => {
              this.$log.error(err);
            });
        })
        .catch((err) => this.$log.error(err));
    },
    getDti(userId, surveyId) {
      dtService
        .getDti(userId, surveyId)
        .then((dti) => {
          this.dti = dti;
          this.imtd = (this.dti.score * 10).toFixed(0);

          this.SET_IMTD(this.imtd);

          if (this.percentage == 100) {
            this.SET_STEP_ACTIVE(0);
          }
        })
        .catch((err) => {
          this.$log.error(err);
          this.SET_STEP_INACTIVE(0);
        });
    },
    getCompany() {
      CompanyService.getCompanyProfile()
        .then((company) => {
          this.company = company;
          if (company) {
            if (
              company.name &&
              company.tributaryId &&
              company.countryCode &&
              company.web &&
              company.linkedIn &&
              company.contributionValue &&
              company.industrialSector &&
              company.trajectory &&
              company.size
            ) {
              this.SET_STEP_ACTIVE(1);
            } else {
              this.SET_STEP_INACTIVE(1);
            }

            if (company.activity && company.activity.trendsVisited) {
              this.SET_STEP_ACTIVE(3);
            } else {
              this.SET_STEP_INACTIVE(3);
            }
          }
        })
        .catch((err) => console.log(err));
    },
    getSubscription() {
      subscriptionService
        .getCurrentUserSubscription()
        .then((suscription) => {
          if (
            suscription &&
            suscription.plan &&
            suscription.plan.name !== "FREE"
          ) {
            this.SET_STEP_ACTIVE(2);
          } else {
            this.SET_STEP_INACTIVE(2);
          }
        })
        .catch((err) => console.log(err));
    },
  },
};
</script>

<style></style>
